mia-2dmyoset-all2one-nonrigid(1)

NAME
mia-2dmyoset-all2one-nonrigid - Non-linear registration of a series of 2D images.

SYNOPSIS
mia-2dmyoset-all2one-nonrigid -i <in-file> -o <out-file> [options] <PLUGINS:2dimage/fullcost>

DESCRIPTION
mia-2dmyoset-all2one-nonrigid This program runs non-rigid registration of a series of images given in an image set. All images are registered to one user defined reference image.

OPTIONS

  File-IO

    -i --in-file=(input, required); string
        input perfusion data set

    -o --out-file=(output, required); string
        output perfusion data set

    --out-filebase=reg
        file name basae for registered files, file type is deducted from the image file type in the input data set.

  Registration

    -k --skip=0
        Skip images at the beginning of the series

    -O --optimizer=gsl:opt=gd,step=0.1
        Optimizer used for minimization

    -l --mg-levels=3
        multi-resolution levels

    -f --transForm=spline
        transformation type
         For supported plugins see PLUGINS:2dimage/transform

    -r --ref=-1
        reference frame (-1 == use image in the middle)

  Help & Info

    -V --verbose=warning
        verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:

        trace - Function call trace
        debug - Debug output
        info - Low level messages
        message - Normal messages
        warning - Warnings
        fail - Report test failures
        error - Report errors
        fatal - Report only fatal errors

    --copyright
        print copyright information

    -h --help
        print this help

    -? --usage
        print a short help

    --version
        print the version number and exit

  Processing

    --threads=-1
        Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).

PLUGINS: 1d/splinebc

mirror
    Spline interpolation boundary conditions that mirror on the boundary

    (no parameters)

repeat
    Spline interpolation boundary conditions that repeats the value at the boundary

    (no parameters)

zero
    Spline interpolation boundary conditions that assumes zero for values outside

    (no parameters)

PLUGINS: 1d/splinekernel

bspline
    B-spline kernel creation , supported parameters are:

    d = 3; int in [0, 5]
        Spline degree.

omoms
    OMoms-spline kernel creation, supported parameters are:

    d = 3; int in [3, 3]
        Spline degree.

PLUGINS: 2dimage/cost

lncc
    local normalized cross correlation with masking support., supported parameters are:

    w = 5; uint in [1, 256]
        half width of the window used for evaluating the localized cross correlation.

lsd Least-Squares Distance measure

    (no parameters)

mi  Spline parzen based mutual information., supported parameters are:

    cut = 0; float in [0, 40]
        Percentage of pixels to cut at high and low intensities to remove outliers.

    mbins = 64; uint in [1, 256]
        Number of histogram bins used for the moving image.

    mkernel = [bspline:d=3]; factory
        Spline kernel for moving image parzen hinstogram. For supported plug-ins see PLUGINS:1d/splinekernel

    rbins = 64; uint in [1, 256]
        Number of histogram bins used for the reference image.

    rkernel = [bspline:d=0]; factory
        Spline kernel for reference image parzen hinstogram. For supported plug-ins see PLUGINS:1d/splinekernel

ncc normalized cross correlation.

    (no parameters)

ngf This function evaluates the image similarity based on normalized gradient fields. Various evaluation kernels are available., supported parameters are:

    eval = ds; dict
        plugin subtype. Supported values are:
            sq - square of difference
            ds - square of scaled difference
            dot - scalar product kernel
            cross - cross product kernel

ssd 2D imaga cost: sum of squared differences, supported parameters are:

    autothresh = 0; float in [0, 1000]
        Use automatic masking of the moving image by only takeing intensity values into accound that are larger than the given threshold.

    norm = 0; bool
        Set whether the metric should be normalized by the number of image pixels.

ssd-automask
    2D image cost: sum of squared differences, with automasking based on given thresholds, supported parameters are:

    rthresh = 0; double
        Threshold intensity value for reference image.

    sthresh = 0; double
        Threshold intensity value for source image.

PLUGINS: 2dimage/fullcost

image
    Generalized image similarity cost function that also handles multi-resolution processing. The actual similarity measure is given es extra parameter., supported parameters are:

    cost = ssd; factory
        Cost function kernel. For supported plug-ins see PLUGINS:2dimage/cost

    debug = 0; bool
        Save intermediate resuts for debugging.

    ref =(input, io)
        Reference image. For supported file types see PLUGINS:2dimage/io

    src =(input, io)
        Study image. For supported file types see PLUGINS:2dimage/io

    weight = 1; float
        weight of cost function.

labelimage
    Similarity cost function that maps labels of two images and handles label-preserving multi-resolution processing., supported parameters are:

    debug = 0; int in [0, 1]
        write the distance transforms to a 3D image.

    maxlabel = 256; int in [2, 32000]
        maximum number of labels to consider.

    ref =(input, io)
        Reference image. For supported file types see PLUGINS:2dimage/io

    src =(input, io)
        Study image. For supported file types see PLUGINS:2dimage/io

    weight = 1; float
        weight of cost function.

maskedimage
    Generalized masked image similarity cost function that also handles multi-resolution processing. The provided masks should be densly filled regions in multi-resolution procesing because otherwise the mask information may get lost when downscaling the image. The reference mask and the transformed mask of the study image are combined by binary AND. The actual similarity measure is given es extra parameter., supported parameters are:

    cost = ssd; factory
        Cost function kernel. For supported plug-ins see PLUGINS:2dimage/maskedcost

    ref =(input, io)
        Reference image. For supported file types see PLUGINS:2dimage/io

    ref-mask =(input, io)
        Reference image mask (binary). For supported file types see PLUGINS:2dimage/io

    src =(input, io)
        Study image. For supported file types see PLUGINS:2dimage/io

    src-mask =(input, io)
        Study image mask (binary). For supported file types see PLUGINS:2dimage/io

    weight = 1; float
        weight of cost function.

PLUGINS: 2dimage/io

bmp BMP 2D-image input/output support. The plug-in supports reading and writing of binary images and 8-bit gray scale images. read-only support is provided for 4-bit gray scale images. The color table is ignored and the pixel values are taken as literal gray scale values.

    Recognized file extensions: .BMP, .bmp

    Supported element types:
        binary data, unsigned 8 bit

datapool
    Virtual IO to and from the internal data pool

    Recognized file extensions: .@

dicom
    2D image io for DICOM

    Recognized file extensions: .DCM, .dcm

    Supported element types:
        signed 16 bit, unsigned 16 bit

exr a 2dimage io plugin for OpenEXR images

    Recognized file extensions: .EXR, .exr

    Supported element types:
        unsigned 32 bit, floating point 32 bit

jpg a 2dimage io plugin for jpeg gray scale images

    Recognized file extensions: .JPEG, .JPG, .jpeg, .jpg

    Supported element types:
        unsigned 8 bit

png a 2dimage io plugin for png images

    Recognized file extensions: .PNG, .png

    Supported element types:
        binary data, unsigned 8 bit, unsigned 16 bit

raw RAW 2D-image output support

    Recognized file extensions: .RAW, .raw

    Supported element types:
        binary data, signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, floating point 32 bit, floating point 64 bit

tif TIFF 2D-image input/output support

    Recognized file extensions: .TIF, .TIFF, .tif, .tiff

    Supported element types:
        binary data, unsigned 8 bit, unsigned 16 bit, unsigned 32 bit

vista
    a 2dimage io plugin for vista images

    Recognized file extensions: .-, .V, .VISTA, .v, .vista

    Supported element types:
        binary data, signed 8 bit, unsigned 8 bit, signed 16 bit, unsigned 16 bit, signed 32 bit, unsigned 32 bit, floating point 32 bit, floating point 64 bit

PLUGINS: 2dimage/maskedcost

lncc
    local normalized cross correlation with masking support., supported parameters are:

    w = 5; uint in [1, 256]
        half width of the window used for evaluating the localized cross correlation.

mi  Spline parzen based mutual information with masking., supported parameters are:

    cut = 0; float in [0, 40]
        Percentage of pixels to cut at high and low intensities to remove outliers.

    mbins = 64; uint in [1, 256]
        Number of histogram bins used for the moving image.

    mkernel = [bspline:d=3]; factory
        Spline kernel for moving image parzen hinstogram. For supported plug-ins see PLUGINS:1d/splinekernel

    rbins = 64; uint in [1, 256]
        Number of histogram bins used for the reference image.

    rkernel = [bspline:d=0]; factory
        Spline kernel for reference image parzen hinstogram. For supported plug-ins see PLUGINS:1d/splinekernel

ncc normalized cross correlation with masking support.

    (no parameters)

ssd Sum of squared differences with masking.

    (no parameters)

PLUGINS: 2dimage/transform

affine
    Affine transformation (six degrees of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

rigid
    Rigid transformations (i.e. rotation and translation, three degrees of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    rot-center = [[0,0]]; 2dfvector
        Relative rotation center, i.e. <0.5,0.5> corresponds to the center of the support rectangle.

rotation
    Rotation transformations (i.e. rotation about a given center, one degree of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    rot-center = [[0,0]]; 2dfvector
        Relative rotation center, i.e. <0.5,0.5> corresponds to the center of the support rectangle.

spline
    Free-form transformation that can be described by a set of B-spline coefficients and an underlying B-spline kernel., supported parameters are:

    anisorate = [[0,0]]; 2dfvector
        anisotropic coefficient rate in pixels, nonpositive values will be overwritten by the 'rate' value..

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    kernel = [bspline:d=3]; factory
        transformation spline kernel.. For supported plug-ins see PLUGINS:1d/splinekernel

    penalty = ; factory
        Transformation penalty term. For supported plug-ins see PLUGINS:2dtransform/splinepenalty

    rate = 10; float in [1, inf)
        isotropic coefficient rate in pixels.

translate
    Translation only (two degrees of freedom), supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

vf  This plug-in implements a transformation that defines a translation for each point of the grid defining the domain of the transformation., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

PLUGINS: 2dtransform/splinepenalty

divcurl
    divcurl penalty on the transformation, supported parameters are:

    curl = 1; float in [0, inf)
        penalty weight on curl.

    div = 1; float in [0, inf)
        penalty weight on divergence.

    norm = 0; bool
        Set to 1 if the penalty should be normalized with respect to the image size.

    weight = 1; float in (0, inf)
        weight of penalty energy.

EXAMPLE
Register the perfusion series given in segment.set by optimizing a spline based transformation with a coefficient rate of 16 pixel using Mutual Information and penalize the transformation by using divcurl with aweight of 2.0.

mia-2dmyoset-all2one-nonrigid -i segment.set -o registered.set
    -f spline:rate=16,penalty=[divcurl:weight=2.0] image:cost=mi,weight=2.0

AUTHOR(s)
Gert Wollny

COPYRIGHT
This software is Copyright (c) 1999-2015 Leipzig, Germany and Madrid, Spain. It comes with ABSOLUTELY NO WARRANTY and you may redistribute it under the terms of the GNU GENERAL PUBLIC LICENSE Version 3 (or later). For more information run the program with the option '--copyright'.